import greenfoot.*;
import java.io.*;
import java.util.Scanner;

/**
 * Reads from the given file and if the given score is lower than the previous, it logs it.
 */

public class BestLives extends Actor
{
    String fFileName;
    int number = 999;
    public int best;        

    public BestLives(String aFileName)
    {
        fFileName = aFileName;
    }

    public BestLives(String aFileName, int number)
    {
        fFileName = aFileName;
        this.number = number;
    }

    protected void addedToWorld(World world)
    {
        try
        {
            read();
        }
        catch(Exception e)
        {
        }
    }

    void write()
    {
        System.out.println("Writing to file named " + fFileName);

        try
        {
            Writer out = new OutputStreamWriter(new FileOutputStream(fFileName));
            out.write(Integer.toString(number));
            out.close();
            getWorld().removeObject(this);
        }
        catch(Exception ex)
        {
            getWorld().removeObject(this);
        }
    }

    void read()
    {
        try
        {
            System.out.println("Reading from file.");
            StringBuilder text = new StringBuilder();
            String NL = System.getProperty("line.separator");
            try
            {
                Scanner scanner = new Scanner(new FileInputStream(fFileName));

                while(scanner.hasNextLine())
                {
                    text.append(scanner.nextLine());
                }

                scanner.close();
            }
            catch(Exception ex)
            {
                getWorld().removeObject(this);
            }
            System.out.println("Text read in: " + text);

            String high = text.toString();
            best = Integer.parseInt(high);
            ((myWorld) getWorld()).BEST_LIVES = best;

            if(number < best)
            {
                write();
            }
            else
            {
                getWorld().removeObject(this);
            }
        }
        catch(NumberFormatException ex)
        {
            write();
        }
    }
}
