import greenfoot.*;
import java.io.*;
import java.util.Scanner;

/**
 * Reads from the log file to determine the best time. If the finished time is better than the previous,
 * it is saved.
 */
public class BestTime extends Actor
{
    String fFileName;
    double number = 99.00;
    public double best;    
    String[] score;
    String cur_score;

    public BestTime(String aFileName)
    {
        fFileName = aFileName;
    }

    public BestTime(String aFileName, double number)
    {
        fFileName = aFileName;
        this.number = number;
    }

    protected void addedToWorld(World world)
    {
        try
        {
            read();
        }
        catch(Exception e)
        {
        }
    }

    void write()
    {
        System.out.println("Writing to file named " + fFileName);

        try
        {
            Writer out = new OutputStreamWriter(new FileOutputStream(fFileName));

            String str = Double.toString(number);

            out.write(str);
            out.close();
            getWorld().removeObject(this);
        }
        catch(Exception ex)
        {
            getWorld().removeObject(this);
        }
    }

    void read()
    {
        try
        {
            System.out.println("Reading from file.");
            StringBuilder text = new StringBuilder();
            String NL = System.getProperty("line.separator");
            try
            {
                Scanner scanner = new Scanner(new FileInputStream(fFileName));

                while(scanner.hasNextLine())
                {
                    text.append(scanner.nextLine());
                }

                scanner.close();
            }
            catch(Exception ex)
            {
                getWorld().removeObject(this);
            }
            System.out.println("Text read in: " + text);

            String high = text.toString();
            best = Double.parseDouble(high);

            ((myWorld) getWorld()).BEST_TIME = best;

            if(number < best)
            {
                write();
            }
            else
            {
                getWorld().removeObject(this);
            }
        }
        catch(NumberFormatException ex)
        {
            write();
        }
    }
}
