import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A dead Elephant. This is what happens when mr.elephant gets too close to spikies.
 */
public class Carcass  extends Actor
{
    float ys;
    int y, x;

    int has_been_on_screen = 0;

    static final int allotted_time = 100; //Change to make the dead body stay longer or shorter.
    static final int wither_speed = 3;      //// Change to make the carcass wither faster or slower.
    static final int y_offset = 9;  ///////// Same as
    static final float gravity = 0.3f;/////// Elephant...

    public Carcass()
    {
        getImage().setTransparency(200);
    }

    /**
     * Act - do whatever the Carcass wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {    
        if(has_been_on_screen < allotted_time)
        {
            if(((myWorld) getWorld()).stage != 17)
            {
                if(!((myWorld) getWorld()).isGround(getX(), getY()+y_offset))
                {
                    ys += gravity;
                }
                else
                {
                    ys = 0;
                    y--;
                }
            }

            else if(((myWorld) getWorld()).stage == 17)
            {
                ScrollingFrame scroll = (ScrollingFrame) getOneIntersectingObject(ScrollingFrame.class);

                if(!scroll.isGround(getX(), getY()+y_offset))
                {
                    ys += gravity;
                }
                else
                {
                    ys = 0;
                    y--;
                }
            }

            y += ys;

            setLocation(getX(), y);

            has_been_on_screen++;
        }
        else
        {
            if(getImage().getTransparency() >= wither_speed)
                getImage().setTransparency(getImage().getTransparency()-wither_speed);

            else
                getWorld().removeObject(this); return;
        }
    }    

    protected void addedToWorld(World world)
    {
        y = getY();
        x = getX();
    }
}
