import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * An image, not actually used as a door. It just shows the user that the play cannot pass it.
 */
public class Door  extends Actor
{   
    static final int sliding_speed = 2;   /// Change to make the door slide open faster or slower.
    static final GreenfootImage orig_image = new GreenfootImage("Door.png"); /// Change for your image.
    /**
     * Act - do whatever the Door wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        /**
         * If the door is closed... Do this.
         */
        if(!((myWorld) getWorld()).door_can_open)
        {
            setLocation(getX(), ((myWorld) getWorld()).door_y);
            getImage().scale(orig_image.getWidth(), orig_image.getHeight());
        }

        /**
         * If the door is open, do this.
         */
        if(((myWorld) getWorld()).door_can_open)
        {
            if(getImage().getHeight() > sliding_speed)
            {
                setLocation(getX(), getY()-sliding_speed/2);
                getImage().scale(getImage().getWidth(), getImage().getHeight()-sliding_speed);
            }
        }
        
        if(((myWorld) getWorld()).button_has_been_untripped)
        {
            setLocation(getX(), ((myWorld) getWorld()).door_y);
            getImage().scale(orig_image.getWidth(), orig_image.getHeight());
        }
    }    
}
