import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * The base image for the stages. I decided to put it here rather than to set the World image to the
 * desired mask to keep the codes cleaner.
 */
public class Mask  extends Actor
{
    myWorld mworld;   
    boolean has_to_set_image = true;
    int acid_wait = 100;

    public void setBackground(int background)
    {
        switch(background)
        {
            /**
             * Insert your own images here. Every time the round increases, a new image will be loaded.
             */
            case 1: setImage(new GreenfootImage("Masks/StageOneMask.png")); break;
            case 2: setImage(new GreenfootImage("Masks/StageTwoMask.png")); break;
            case 3: setImage(new GreenfootImage("Masks/StageThreeMask.png")); break;
            case 4: setImage(new GreenfootImage("Masks/StageFourMask.png")); break;
            case 5: setImage(new GreenfootImage("Masks/StageFiveMask.png")); break;
            case 6: setImage(new GreenfootImage("Masks/StageSixMask.png")); break;
            case 7: setImage(new GreenfootImage("Masks/StageSevenMask.png")); break;
            case 8: setImage(new GreenfootImage("Masks/StageEightMask.png")); break;
            case 9: setImage(new GreenfootImage("Masks/StageNineMask.png")); break;
            case 10: setImage(new GreenfootImage("Masks/StageTenMask.png")); break;
            case 11: setImage(new GreenfootImage("Masks/StageElevenMask.png")); break;
            case 12: setImage(new GreenfootImage("Masks/StageTwelveMask.png")); break;

            case 13: setImage(new GreenfootImage("Masks/StageThirteenMask.png")); break;
            case 14: setImage(new GreenfootImage("Masks/StageFourteenMask.png")); break;
            case 15: setImage(new GreenfootImage("Masks/StageFifteenMask.png")); break;
            case 16: setImage(new GreenfootImage("Masks/StageSixteenMask.png")); break;

            /**
             * So, this is a special scrolling level. Yeah, I know. It's boss.
             */
            case 17: prepare_for_scroll(); break;

            case 18: setImage(new GreenfootImage("Masks/StageSixMask.png")); break;
            case 19: setImage(new GreenfootImage("Masks/StageNineteenMask.PNG")); break;

            case 20: setImage(new GreenfootImage("Masks/StageFourteenMask.png"));
            ((myWorld) getWorld()).acid_trip = true; break;

            case 21: setImage(new GreenfootImage("Masks/StageNineMask.png")); break;
            case 22: setImage(new GreenfootImage("Masks/StageElevenMask.png")); break;
            case 23: setImage(new GreenfootImage("Masks/EndMask.PNG")); break;
        }
    }

    private void prepare_for_scroll()
    {
        /**
         * Yeah, I don't know why I did this...
         */
        if(getWorld().getObjects(ScrollingMask.class).isEmpty())
        {
            getWorld().addObject(new ScrollingMask(), getX()*2, getY());
            getWorld().addObject(new ScrollingFrame(), getX()*2, getY()-25);
        }
        else
        {
            getWorld().removeObjects(getWorld().getObjects(ScrollingMask.class));
            getWorld().removeObjects(getWorld().getObjects(ScrollingFrame.class));

            getWorld().addObject(new ScrollingMask(), getX()*2, getY());
            getWorld().addObject(new ScrollingFrame(), getX()*2, getY()-25);
            getWorld().removeObjects(getWorld().getObjects(Mask.class)); 
            return;
        }
    }

    public void act()
    {
        if(mworld.stage == 12 && mworld.show_path && has_to_set_image)
        {
            has_to_set_image = false;
            setImage(new GreenfootImage("Masks/StageTwelvePathMask.png"));
        }
        else if(mworld.stage == 12 && !mworld.show_path && !has_to_set_image)
        {
            has_to_set_image = true;
            setImage(new GreenfootImage("Masks/StageTwelveMask.png"));
        }

        if(mworld.acid_trip)
        {
            acid_trip();
        }
    }

    private void acid_trip()
    {
        if(acid_wait < 15)
        {
            acid_wait++;
        }
        else
        {
            int mask_select;
            mask_select = Greenfoot.getRandomNumber(18)+1;

            if(mask_select == 3 || mask_select == 12 || mask_select == 15 || mask_select == 16 || mask_select == 17)
            {
                mask_select = 0;
            }
            if(mask_select != 0)
                setBackground(mask_select);

            acid_wait = 0;
        }
    }

    protected void addedToWorld(World world)
    {
        mworld = ((myWorld) getWorld());

        setBackground(mworld.stage);
    }
}
