import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Font;
/**
 * Counts the time since the page was loaded, not necessarily when the applet was started.
 * 
 * Like a FPS counter, it uses the System.currentTimeMillis to find the time.
 */
public class Timer  extends Actor
{
    private long startTime = 0;
    private long stopTime = 0;
    private boolean running = false;
    private long minutes = 0;
    GreenfootImage image = new GreenfootImage(100,50);
    private long clearSeconds = 0;
    Font font = new Font("helvetica", Font.BOLD, 16);

    public Timer()
    {
        setImage(image);
    }

    public void addedToWorld(World world)
    {
        image.setFont(font);
        started();
    }

    public void started()
    {
        startTime = System.currentTimeMillis();
        running = true;
    }

    public void stopped()
    {
        stopTime = System.currentTimeMillis();
        running = false;
    }

    public void act()
    {
        if(!((myWorld) getWorld()).is_running)
        {
            stopped();
        }
        
        if(running && ((myWorld) getWorld()).is_running)
        {
            image.clear();
            if(getElapsedTimeSeconds() >= 10)
                image.drawString(((myWorld) getWorld()).minutes + ":" + getElapsedTimeSeconds(), 20, 25);
            else
                image.drawString(((myWorld) getWorld()).minutes + ":0" + getElapsedTimeSeconds(), 20, 25);

            if(getElapsedTimeSeconds() >= 60)
            {
                clearSeconds += 60;
                ((myWorld) getWorld()).minutes++;
            }

            if(!((myWorld) getWorld()).music.isPlaying())
            {
                ((myWorld) getWorld()).music.play();
            }
        }
        
        ((myWorld) getWorld()).seconds = getElapsedTimeSeconds();
    }

    /**
     * Returns the time elapsed in seconds.
     */
    public long getElapsedTimeSeconds()
    {
        long elapsed;
        if(running)
        {
            elapsed = ((System.currentTimeMillis() - startTime) / 1000 - clearSeconds);
        }
        else
        {
            elapsed = ((stopTime - startTime) / 1000);
        }
        return elapsed;
    }
}
