import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;

/**
 * The world in which this entire level resides in.
 */
public class myWorld  extends World
{
    /**
     * Long list of variables. Feel free to edit the ones with comments.
     */

    static final int total_stages = 99;     //// Increase if you make more stages.

    GreenfootSound music = new GreenfootSound("Strobe.mp3");

    int BEST_LIVES;
    double BEST_TIME;

    GreenfootImage frame[] = new GreenfootImage[total_stages];

    static final int button_x = 351;   //// Change for a different button location
    static final int button_y = 168;

    static final int door_x = 605;     //// Change for a different door location.
    static final int door_y = 324;

    boolean scrolling = false;
    boolean acid_trip = false;

    int scroll_speed = 0;      //// For the scrolling level(s)
    int scroll_position;

    ScrollingFrame scroll;

    int stage = 1;
    int deaths = 0;

    static final Color ground_color = Color.BLACK; //// Change these if you want to use different colors
    static final Color hurt_color = Color.RED;     //// in the frame. You can also use
    static final Color bounce_color = Color.YELLOW;//// Color color = new Color(int r, int g, int b);

    static int spawn_x = 110;    //// Change to have the player spawn
    static int spawn_y = 142;    //// somewhere else.

    long minutes, seconds;
    boolean end = false;

    static final int width = 699;        //// Change these
    static final int height = 400;       //// to adjust the properties
    static final boolean bounded = false; //// of the World.

    boolean can_act = false;
    boolean is_running = false;

    boolean door_can_open = false;
    boolean button_has_been_tripped = false;
    boolean mustOpen = false;
    boolean reversed_door = false;
    boolean mustClose = false;
    boolean button_has_been_untripped = false;
    boolean show_path = false;
    boolean special_frame = false;    ////// For levels with custom frames.
    boolean special_mask = false;     ////// For levels with custom masks.

    /**
     * Constructor for objects of class myWorld. Note that the World MUST BE CALLED myWorld.
     * 
     */
    public myWorld() 
    {    
        // Create a new world with 699x400 cells with a cell size of 1x1 pixels, bounded.
        super(width, height, 1, bounded); 

        setPaintOrder(TextLives.class, TextTime.class, transition.class, AlphabetTiles.class, Timer.class, Deaths.class, TextFeature.class, Elephant.class, Carcass.class, Button.class, switchy.class, Door.class, ScrollingMask.class, Mask.class, ScrollingFrame.class);
        resetGame();
    }

    public void started()
    {
        is_running = true;
        music.play();
    }

    public void stopped()
    {
        is_running = false;
        music.pause();
    }

    public void act()
    {
        if(!music.isPlaying())
        {
            music.play();
        }

        /**
         * Not the way I would've like to do the door opening, but the door is acting up on me.
         */
        if(button_has_been_untripped && !mustClose)
        {
            mustClose = true;
            frame[stage] = new GreenfootImage("FrameClosed.PNG");
        }

        if(door_can_open && mustOpen && !special_frame)
        {
            frame[stage] = new GreenfootImage("FrameOpen.PNG");
            mustOpen = false;
        }
        if(!door_can_open && !mustOpen && !special_frame)
        {
            frame[stage] = new GreenfootImage("FrameClosed.PNG");
            mustOpen = true;
        }
    }

    /**
     * Level switching methods. Jump ahead to cleanUp() to edit your own code.
     */
    public void resetGame()
    {      
        cleanUp();
        stage = 1;
        door_can_open = false;
        reversed_door = false;
        special_frame = false;
        mustOpen = false;
        deaths = 0;
        setStage(1);

        addObject(new BestTime("BESTTIME.txt"), -100, -100);
        addObject(new BestLives("BESTLIVES.txt"), -100, -100);

        removeObjects(getObjects(Timer.class));
        removeObjects(getObjects(Deaths.class));
        removeObjects(getObjects(TextLives.class));
        removeObjects(getObjects(TextTime.class));
        addObject(new TextTime("Best Time: ", 13), 99, 11);
        addObject(new TextLives("Least Deaths: ", 13), 652, 11);
        addObject(new Timer(), 679, 380);
        addObject(new Deaths(), 660, 393);
    }

    public void restartStage() 
    {
        setStage(stage);
    }

    public void nextStage()
    {
        if(stage < total_stages)
            stage++;    

        addObject(new transition(), width+380, height/2);
    }

    public void setStage(int stage) 
    {
        this.stage = stage;

        special_mask = false;
        can_act = false;
        scrolling = false;
        cleanUp();

        show_path = false;
        special_frame = false;
        mustClose = false;
        button_has_been_untripped = false;
        reversed_door = false;
        mustOpen = false;
        door_can_open = false;
        button_has_been_tripped = false;

        switch(stage)
        {
            case 1: stage_one(); break;
            case 2: stage_two(); break;
            case 3: stage_three(); break;
            case 4: stage_four(); break;
            case 5: stage_five(); break;
            case 6: stage_six(); break;
            case 7: stage_seven(); break;
            case 8: stage_eight(); break;
            case 9: stage_nine(); break;
            case 10: stage_ten(); break;
            case 11: stage_eleven(); break;
            case 12: stage_twelve(); break;
            case 13: stage_thirteen(); break;
            case 14: stage_fourteen(); break;
            case 15: stage_fifteen(); break;
            case 16: stage_sixteen(); break;
            case 17: stage_seventeen(); break;
            case 18: stage_eighteen(); break;
            case 19: stage_nineteen(); break;
            case 20: stage_twenty(); break;
            case 21: stage_twenty_one(); break;
            case 22: stage_twenty_two(); break;
            case 23: end(); break;
        }

        can_act = true;
    }

    public void cleanUp()
    {
        /**
         * Add all your actors you want to be removed each level here.
         */
        removeObjects(getObjects(Elephant.class));
        removeObjects(getObjects(Mask.class));
        removeObjects(getObjects(TextFeature.class));
        removeObjects(getObjects(transition.class));
        removeObjects(getObjects(ScrollingMask.class));
        removeObjects(getObjects(switchy.class));

        addObject(new TextFeature("Stage " + stage, 14), 58, 383);
        addObject(new Mask(), width/2, height/2);
        addObject(new Elephant(), spawn_x, spawn_y);

        /**
         * Put in the level descriptions. Aprx algorithm for finding x location = String length*100 - 10.
         */
        if(stage==1)
            addObject(new TextFeature("Arrow keys required.", 11), 224, 380);
        if(stage==2)
            addObject(new TextFeature("Not always straight forward.", 11), 253, 380);
        if(stage==3)
            addObject(new TextFeature("Think before doing.", 11), 220, 380);
        if(stage==4)
            addObject(new TextFeature("Alternate control scheme.", 11), 228, 380);
        if(stage==5)
            addObject(new TextFeature("Hidden passageway.", 11), 199, 380);
        if(stage==6)
            addObject(new TextFeature("The alphabet.", 11), 170, 380);
        if(stage==7)
            addObject(new TextFeature("Free floating.", 11), 171, 380);
        if(stage==8)
            addObject(new TextFeature("Dull appearances.", 11), 183, 380);
        if(stage==9)
            addObject(new TextFeature("No returns, no refunds.", 11), 215, 380);
        if(stage==10)
            addObject(new TextFeature("Wiggle Ant Sand Door.", 11), 205, 380);
        if(stage==11)
            addObject(new TextFeature("A bit bouncy here.", 11), 204, 380);
        if(stage==12)
            addObject(new TextFeature("Tunnel.", 11), 133, 380);
        if(stage==13)
            addObject(new TextFeature("Hop, skip, and a jump.", 11), 213, 380);
        if(stage==14)
            addObject(new TextFeature("Enter if you dare.", 11), 203, 380);
        if(stage==15)
            addObject(new TextFeature("Back where you came from.", 11), 223, 380);
        if(stage==16)
            addObject(new TextFeature("Don't believe everything.", 11), 223, 380);
        if(stage==17)
            addObject(new TextFeature("Up and out.", 11), 150, 380);
        if(stage==18)
            addObject(new TextFeature("Play dead.", 11), 153, 380);
        if(stage==19)
            addObject(new TextFeature("Now we're talking.", 11), 203, 380);
        if(stage==20)
            addObject(new TextFeature("Feeling dizzy yet?", 11), 203, 380);
        if(stage==21)
            addObject(new TextFeature("Do it from memory.", 11), 203, 380);
        if(stage==22)
            addObject(new TextFeature("Enjoy this one :).", 11), 203, 380);

        /**
         * Put a button, a door, and a mask in if there isn't any currently in the World.
         * 
         * Mostly just a failsafe, in case one of them glitches out of the World, or is removed.
         */
        if(getObjects(Button.class).isEmpty() && stage != 18)
            addObject(new Button(), button_x, button_y);

        if(getObjects(Door.class).isEmpty())
            addObject(new Door(), door_x, door_y);

        if(getObjects(Mask.class).isEmpty())
            addObject(new Mask(), width/2, height/2);
    }

    public boolean isGround(double x, double y)
    {
        try
        {
            if(frame[stage].getColorAt((int)x, (int)y).equals(ground_color))
                return true;

            return false;
        }
        catch(IndexOutOfBoundsException ex)
        {
            return false;
        }
    }

    public boolean isBounce(double x, double y)
    {
        try
        {
            if(frame[stage].getColorAt((int)x, (int)y).equals(bounce_color))
                return true;

            return false;
        }
        catch(IndexOutOfBoundsException ex)
        {
            return false;
        }
    }

    public boolean isHurt(double x, double y)
    {
        try
        {
            if(frame[stage].getColorAt((int)x, (int)y).equals(hurt_color))
                return true;

            return false;
        }
        catch(IndexOutOfBoundsException ex)
        {
            return false;
        }
    }

    ///////////////////////////////////////////////////////////
    //////////////////////STAGE METHODS////////////////////////
    ///////////////////IN NUMERICAL ORDER//////////////////////
    ///////////////////////////////////////////////////////////

    public void stage_one()
    {
        ///Normal stage
    }

    public void stage_two()
    {
        ///Normal stage with reversed controls
    }

    public void stage_three()
    {
        button_has_been_tripped = true;
        reversed_door = true;

        /////door starts open stage
    }

    public void stage_four()
    {
        /// mouse controlled stage
    }

    public void stage_five()
    {
        special_frame = true;
        frame[stage] = new GreenfootImage("SurpriseFrame.png");
        removeObjects(getObjects(Button.class));

        ///// hidden passage stage
    }

    public void stage_six()
    {
        removeObjects(getObjects(Button.class));

        ///alphabet stage
    }

    public void stage_seven()
    {
        ///less gravity stage
    }

    public void stage_eight()
    {
        special_frame = true;
        frame[stage] = new GreenfootImage("BounceSpikesFrame.png");

        ///// bouncy spikes stage
    }

    public void stage_nine()
    {
        //// only forward stage
    }

    public void stage_ten()
    {
        //// wasd stage
    }

    public void stage_eleven()
    {
        /// bouncing stage
    }

    public void stage_twelve()
    {
        special_frame = true;
        frame[stage] = new GreenfootImage("TunnelFrame.png");
        //// Hidden tunnel stage
    }

    public void stage_thirteen()
    {
        if(!getObjects(Button.class).isEmpty())
            button_has_been_tripped = true;
        //// no jumps stage
    }

    public void stage_fourteen()
    {
        removeObjects(getObjects(Button.class));
        //// Enter key opens door.
    }

    public void stage_fifteen()
    {
        spawn_x = 83;
        spawn_y = 332;

        removeObjects(getObjects(Elephant.class));
        addObject(new Elephant(), spawn_x, spawn_y);

        removeObjects(getObjects(Door.class));

        special_frame = true;
        frame[stage] = new GreenfootImage("FrameOpenManipulated.png");
        ///Horizontally mirrored stage
    }

    public void stage_sixteen()
    {
        spawn_x = 110;
        spawn_y = 142;

        removeObjects(getObjects(Elephant.class));
        addObject(new Elephant(), spawn_x, spawn_y);

        special_frame = true;
        frame[stage] = new GreenfootImage("FrameOpen.PNG");
        removeObjects(getObjects(Door.class));
        ////// Fake door scenery stage
    }

    public void stage_seventeen()
    {
        special_frame = true;
        special_mask = true;
        scrolling = true;

        removeObjects(getObjects(Button.class));
        removeObjects(getObjects(Door.class));

        /**
         * Leave the frame for this stage blank.
         */
        frame[stage] = new GreenfootImage(width, height);

        //// Scrolling stage, Sorry the code is so messy. It's all over the place.
        //// Mask.class adds the ScrollingFrame and ScrollingMask, ScrollingFrame repaints itself,
        //// ScrollingMask moves...
    }

    public void stage_eighteen()
    {
        addObject(new switchy(), 424, 368);
        removeObjects(getObjects(ScrollingFrame.class));
        removeObjects(getObjects(ScrollingMask.class));

        //// Carcass opens the door stage
    }

    public void stage_nineteen()
    {
        special_frame = true;

        frame[stage] = new GreenfootImage("EpicFrame.PNG");

        /// Tons of spikes stage
    }

    public void stage_twenty()
    {
        /// Random Backgrounds stage
    }

    public void stage_twenty_one()
    {
        acid_trip = false;

        //// Invisible Elephant stage
    }

    public void stage_twenty_two()
    {
        removeObjects(getObjects(Button.class));
        addObject(new switchy(), button_x, button_y);
        addObject(new Elephant(true), 479, 90);
        
        // two elephants stage
    }

    public void end() 
    {
        end = true;
        special_frame = true;

        removeObjects(getObjects(Button.class));
        addObject(new Button(), 372, 81);

        String mins = Long.toString(minutes);
        String secs = Long.toString(seconds);

        String finalTime = mins + "." + secs;
        double endTime = Double.parseDouble(finalTime);

        System.out.println(deaths);
        System.out.println(endTime);

        addObject(new BestLives("BESTLIVES.txt", deaths), -100, -100);
        addObject(new BestTime("BESTTIME.txt", endTime), -100, -100);

        frame[stage] = new GreenfootImage("EndFrame.PNG");
    }
}
